;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; THE 16x16 TILEMAP ROUTINE.
;
; A VERY SPECIAL THANKS TO CHICKENDUDE
; FOR LETTING ME USE THIS ROUTINE.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;lleva: 
;de = xcoord 
;b = y coord 
umf:
updatemapfull:
DrawMapFull:
dibMapa: 

	di

	ld hl, MapLocation

	ld de, (MapX)
	ld a, e
	and %00001111
	ld (xOff), a
	srl d \ rr e
	srl d \ rr e
	srl d \ rr e
	srl d \ rr e

	add hl,de 

	ld de, (MapY)
	ld a, e
	and %00001111
	ld (YOff), a
	srl d \ rr e
	srl d \ rr e
	srl d \ rr e
	srl d \ rr e

	
	ld a, (MapWidth)
	ld b, a

	add hl,de 
	djnz $-1 
	exx 
	ld hl,plotsscreen	;donde guardar el mapa antes de dibujarlo a la pantalla, es decir, el gbuf 
	ld de,13		;numero de columnas en gbuf menos uno (por el inc hl') 
	ld bc,$0705		;dibujar 7 columnas y 5 filas de sprites (en la pantalla caben 6x4)) 


dibFila: 

	push hl	;guardar gbuf 
	exx 
	push hl		;save map loc 
	ld l,(hl)	;numero del sprite 

;If the tile being drawn is one of bonus letters, 
;don't use the default 256 tile set.  Instead use
;a character from the 16x16 font tileset.

	ld a, l
	cp 223
	jr c, NoBonusTile
	cp 239
	jr nc, NoBonusTile

IsBonusTile:

;We are drawing a 16x16 picture of one character
;from the bonus word.  Is it the first character in the bonus
;word?  The second?  The third?

	sub 223


	ld hl, (OriginalBonusWordPointer)
	call Add_A_To_HL


	ld a, (hl)

;If the character is '@', it's the accent mark, the apostrophe.
;It requires special attention.

	cp '@'
	jr nz, _

;Where is the accent mark character in the 16x16 font?

	ld a, (apostrophecharacter)
	jr ++_
_
	sub 97	;Since the foreign language font starts at
		;lowercase 'a', subtract this value to get to
		;the right character in the 16x16 font.
_

;Draw a character from the 16x16 foreign language font, not the
;normal tileset.

	ld l, a
	ld h, 0

	add hl,hl	;x2 
	add hl,hl	;x4 
	add hl,hl	;x8 
	add hl,hl	;x16 
	add hl,hl	;x32 

	ld bc, (VariableLocation+1)
	add hl,bc	;primer byte en sprite
	ld bc, (SixteenFontLocation)
	add hl, bc
	ld a, (VariableLocation)


	ld b,32
	ld de, SmallEditRAM

	call DoFlashToRAM	;The tile is in archive, so copy it to RAM.


	ld hl, smallEditRAM
	jr FinallyDrawTileMapTile




NoBonusTile:


	ld h,0 
	ld bc,Tileset 
	add hl,hl	;x2 
	add hl,hl	;x4 
	add hl,hl	;x8 
	add hl,hl	;x16 
	add hl,hl	;x32 
	add hl,bc	;primer byte en sprite 

FinallyDrawTileMapTile

	ld b,16		;16 filas en sprite 
dibSprite: 
	ld a,(hl)	;pixeles del sprite a dibujar 
	inc hl		;proximo conjunto de pixeles 
	exx		;cambiar a los registros alternativos 
		ld (hl),a 
		inc hl	;proximo byte en gbuf 
	exx 
	ld a,(hl) 
	inc hl		;2 conjunto (pixels son 16x16: 2 bytes de ancho) 
	exx 
		ld (hl),a 
		add hl,de	;bajar a la proxima fila 
	exx 
	djnz dibSprite 
	 
	pop hl		;posicion en el mapa 
	inc hl 
	exx 
		pop hl	;gbuf anterior 
		inc hl 
		inc hl	;saltar dos bytes porque los sprites son de 16x16 
		djnz dibFila 

	exx 
	ld a,(mapWidth) 
	sub 7			;ya hemos avanzado un cierto numero de tiles 
	ld e,a 
	ld d,0 
	add hl,de 
	exx 

		ld e,14*15	; 
		add hl,de 
		ld e,13 
		ld b,7 
		dec c 
		jr nz,dibfila


	call UpdateRotation
	call drawgbuf

	ld hl, appbackupscreen
	ld de, plotsscreen
	ld bc, 768
	ldir


	ret





SafeCopy:	
	               

	ld hl,PlotSScreen  
	ld d, 0
	ld c,$10

setrow:
	in a, ($10)
	bit 7, a
	jr nz,setrow

	ld a, $80
	out ($10),a

	ld a,$20
col:
	in e,(c)
	bit 7, e
	jr nz, col

	out ($10),a

	push af
	ld b,64
row:
	ld a,(hl)
rowwait:
	in e,(c)
	bit 7, e
	jr nz, rowwait
	out ($11), a
	ld e, 12
	add hl,de
	djnz row
	pop af
	dec h
	dec h
	dec h
	inc hl
	inc a
	cp $2c
	jp nz,col
	ret






Add_A_To_HL:

	add a,l
	ld l,a
	ret nc
	inc h
	ret





