defpage(1)









PageOneDisplayNewGrizzle:

	di


;If there's too many enemies, the player dies.

	ld hl, EnemyList
	ld b, 10
	ld de, 7
_
	ld a, (hl)
	or a
	jr z, RoomForEnemy
	add hl, de
	djnz -_

	ld a, 89
	ld (DeathWish), a
	ret
	

RoomForEnemy:

;We can put another gruzzle on the map.
;Save the location where the gruzzle will be placed in the
;list of enemies.

	ld (BadQuestion + 1), hl

;Pick a random gruzzle to add to the map.

	ld a, r
	and %00000011
	inc a
	add a, 27
	ld (BadQuestion), a	;One of 4 grizzles
	
	ret
	



PageOneDrawCharacter:

;Draws the player.


;If the player is out of nukes yet tries to fire,
;draw this sprite.

;PlayerrQuestionsPlayer is the time to show the player saying
;'I don't have any nukes!'


	ld a, (PlayerrQuestionsPlayer)
	or a
	jr z, NoPlayerQuestionsPlayer
	dec a
	ld (PlayerrQuestionsPlayer), a

DrawNoNukeNotify

	ld e, 24
	call DrawPlayerHandsUp

	ret



NoPlayerQuestionsPlayer:

;Is the player trying to aim a nuke?

;Can't aim for a nuke if the player is running or jumping

	ld a, $FE
	out (1), a
	ex (sp), hl
	ex (sp), hl
	in a, (1)
	inc a
	jr nz, NoNukeCharacter

;If the player isn't running or jumping, it still takes
;time before he can aim the weapon.

	ld a, (ReadyWeaponTimer)
	or a
	jr z, _

	dec a
	ld (ReadyWeaponTimer), a
	jr NoNukeCharacter
_

;Is the player pressing the ALPHA key, wanting to aim the
;weapon?

	ld a, $DF
	out (1), a
	ex (sp), hl
	ex (sp), hl
	in a, (1)


	bit 7, a
	jr nz, NoNukeCharacter

;Out of nukes?  If so, for a certain amount of time the
;character will tell the player that he doesn't have any nukes

	ld a, (Nukes)
	or a
	jr nz, NukeCharacter

	ld a, 30
	ld (PlayerrQuestionsPlayer), a
	jr DrawNoNukeNotify


NukeCharacter:

;Draw the player aiming his weapon

	di

	ld ix, Sprites + (32*4)
	ld hl, plotsscreen + (34*12+7)
	ld de, 1

	ld a, (LastDirection)
	cp Left
	jr nz, FinallyDrawNuke

	ld ix, Sprites + (32*9)
	ld hl, plotsscreen + (34*12+4)

	dec de
	dec de


FinallyDrawNuke:

	ld a, (NukeY)
	or a
	jr z, ++_


	ld b, 5

_
	ld (hl), %11111111
	add hl, de
	djnz -_

_

	ld a, 40
	ld e, 24
	ld b, 16
	ld iy, Sprites + (32*23)
	call DoubleMaskedSpriteMap


	ret

NoNukeCharacter:

	di

	ld a, (Climbing)
	or a
	jr z, NoClimbCharacter

	ld ix, Sprites + (32*20)
	ld iy, Sprites + (32*21)
	ld a, 40
	ld e, 24
	ld b, 16

	call DoubleMaskedSpriteMap


	ret

NoClimbCharacter:

	ld a, (JumpLength)
	or a
	jr z, NoDrawJumpCharacter


DrawJumpCharacter:

	ld ix, Sprites + 96
	ld a, (LastDirection)
	cp Left
	jr nz, FinallyDrawSprite

	ld ix, Sprites + 96 + 128 + 32
	jr FinallyDrawSprite

NoDrawJumpCharacter:

	ld a, (Falling)
	or a
	jr nz, DrawJumpCharacter


	ld a, (LastDirection)
	cp LEFT
	jr z, _
	ld ix, Sprites-32

	call DrawPlayerFramer


	jr ++_
_
	ld ix, Sprites + 128
	call DrawPlayerFramer

FinallyDrawSprite:
_
	ld a, 40
	ld e, 24
	ld b, 16
	call Draw16x16sprite
	ret


DrawPlayerFramer:

	ld de, 8
	ld a, (PlayerFrame)
	inc a
	cp 12
	jr c, NoMiddlePlayerRight

	ld a, 4

NoMiddlePlayerRight:
	and %11111100
	add a, 4

	ld b, a
PlayerFrameLoop:

	add ix, de
	djnz PlayerFrameLoop

	ret



PageOneDeathWish:

LoopPlayerDead:


	ld a, (DeathWish)
	dec a
	ld (DeathWish), a

	
	ret z


	ld hl, savesscreen
	ld de, plotsscreen
	ld bc, 768
	ldir

	cp 65
	jr nc, PlayerDieUp

PlayerDieDown:

	neg
	add a, 65

	jr PlayerDieDie

PlayerDieUp:

	sub 89-24

PlayerDieDie
	ld e, a

	call DrawPlayerHandsUp

	B_CALL _GrBufCpy
	di
	jr LoopPlayerDead
	

PageOneDrawAttack:


;Get the enemy Y

	ld l, (ix)
	ld h, (ix + 1)

	ld c, (ix-1)

#ifdef DOBoss

	ld a, (ix-1)
	cp 5
	jr nz, GetRidOfEnemy
	
	ld a, 20
	ld (ReadyWeaponTimer), a
	
	ld a, (BossHitsLeft)
	dec a
	jr nz, BossNotDeadYet

	ld a, 255

;A special value that tells the calculator to animate the
;explosion of the boss

	ld (BossHitsLeft), a
	jr GetRidOfEnemy

BossNotDeadYet:

	ld (BossHitsLeft), a

	jr NoGetRidOfBoss

#endif
	


GetRidOfEnemy:

	ld (ix-1), 0	;Get rid of gruzzle!

NoGetRidOfBoss:

	ld de, (MapX)
	or a
	sbc hl, de

	ld a, (LastDirection)
	cp Left
	jr nz, _


	dec l
	dec l
_


	ld a, l

	ld (NukeX),a

#ifdef DOBOSS

	ld a, c
	cp 5
	jr nz, BNoBoss

	ld b, 11
	jr DrawNukeLoop

BNoBoss:


#endif

	ld b, 23



DrawNukeLoop:



	di

	push bc
	ld hl, savesscreen
	ld de, plotsscreen
	ld bc, 768
	ldir

	ld a, (NukeY)
	ld e, a
	inc a
	ld (NukeY), a
	ld a, (NukeX)
;	sub 2
	ld b, 16

	ld ix, sprites+ (32*24)
	ld iy, sprites + (32*23)
	call DoubleMaskedSpriteMap
	B_CALL _GrBufCpy
	di
	pop bc
	djnz DrawNukeLoop


	ld b, 3
	ld ix, sprites + (32*25)
	ld iy, sprites + (32*26)

_
	push bc
	ld hl, savesscreen
	ld de, plotsscreen
	ld bc, 768
	ldir

	ld a, (NukeY)
	ld e, a
	ld a, (NukeX)
;	sub 2
	ld b, 16

	push iy
	call DoubleMaskedSpriteMap
	pop iy

	ld de, 32
	add ix, de
	add iy, de
	add iy, de

	ld b, 20
	push iy
FG:
	push bc
	
	ld iy, flags
	B_CALL _GrBufCpy
	di


	pop bc
	djnz FG

	pop iy
	pop bc
	
	djnz -_


	
	ld hl, Nukes
	dec (hl)
	ld iy, flags
	di
	ret



Draw16x16Sprite:

;Double Masked Sprite Routine by Jon Martin
;for placing a 16xn sprite with a mask on plotsscreen
;ANDs a sprite mask,1's are transperent, 0's are blank
;ORs a sprite where the mask was placed (all black parts of sprite must match 0's on the mask)
;inputs:
;a=column
;b=number of rows of sprite
;e=row
;ix=sprite pointer
;iy=sprite mask pointer
;outputs:
;sprite copied to plotsscreen
;destroys:
;all (including IY) except shadows
doublemaskedsprite:

	push bc
	push ix
	pop iy
	ld bc, 256 + 64
	add iy, bc
	pop bc

DoubleMaskedSpriteMap:

	ld 		h,0	 		;multiply e by 12		
 	ld 		l,e					
 	ld 		d,h 		
 	add 		hl,hl		
 	add 		hl,de		
 	add 		hl,hl		
 	add 		hl,hl		 	;e*12=hl
 	ld 		de,plotsscreen		
 	add 		hl,de			;now hl is on correct row of plotsscreen
 	ld 		e,a			
 	srl		e			;divide e by8
 	srl 		e			
 	srl 		e			
 	ld 		d,0			
 	add 		hl,de			;now hl is at top-left byte of where sprite goes
 	and 		7			;check if row is multiple of 8, if it is not then a=bitmask
 	jp 		z,daligned		;if it is, then the sprite is aligned
 	ld 		c,a			;now c contains bitmask
drowloop:					;this loop will be done b times
 	push 		bc			;save bc for later
 	ld 		b,c			;b has bitmask
 	ld 		d,(ix)			;d is first byte of sprite
 	ld 		e,(ix+1)		;e is second
 	xor 		a			;a is 0
dshiftloop1:		
 	srl 		d			;rotate d into e, e into a
 	rr 		e
 	rra
 	djnz 		dshiftloop1		;do this as many times as bitmask says
 	push 		de			;now save sprite data
 	push 		af			
 	ld		b,c			;now b has bitmask again
 	ld 		d,(iy)			;d is first byte of sprite mask
 	ld 		e,(iy+1)		;e is second
	ld a, $FF			;a is 0
dshiftloop2:	
	scf				
 	rr d			;rotate d into e, e into a
 	rr 		e 
 	rra
 	djnz 		dshiftloop2
 	inc 		hl			;move hl to byte for a
 	inc 		hl
 	and 		(hl)			;and logic a with that location
 	ld 		(hl),a			;now the byte is masked
 	pop 		af			;now use old a
 	or 		(hl)			;use or logic
 	ld 		(hl),a			;now the byte has been properly written
 	ld 		a,e			;go to e, 1 left of a
 	dec 		hl
 	and 		(hl)
 	ld 		(hl),a
 	dec 		hl
 	ld 		a,d
 	and 		(hl)
 	ld 		(hl),a
 	pop 		de
 	ld 		a,d
 	or 		(hl)
 	ld 		(hl),a
 	inc 		hl
 	ld 		a,e
 	or 		(hl)
 	ld 		(hl),a
 	pop		bc
 	ld 		de,11
 	add 		hl,de
 	inc 		ix
 	inc 		ix
 	inc 		iy
 	inc 		iy
 	djnz 		drowloop
 	ld 		iy,flags		
 	ret			
daligned:
  	ld 		de,11
dalignedloop:
 	ld 		a,(iy)
 	and 		(hl)
 	ld 		(hl),a
 	ld 		a,(ix)
 	or 		(hl)
 	ld 		(hl),a
 	inc 		hl
 	ld		a,(iy+1)
 	and 		(hl)
 	ld 		(hl),a
 	ld 		a,(ix+1)
 	or 		(hl)
 	ld 		(hl),a
 	inc 		ix
 	inc 		ix
 	inc 		iy
 	inc 		iy
 	add 		hl,de
 	djnz 		dalignedloop
 	ld 		iy,flags
 	ret   

DrawPlayerHandsUp:

	ld a, 40

	ld ix, Sprites + (32*22)
	ld iy, Sprites + (32*21)

	ld b, 16

	call DoubleMaskedSpriteMap

	ret

Sprites:

.option BM_SHD = 2
.option bm_min_w = 16


#include "c:\users\Rickie\Desktop\Slova\Sprites.bmp"

PageOneDecompressLevel:

	ex de, hl

	ld a, (hl)
	inc hl
	ld (MapLocation -4), a
	ld a, (hl)
	inc hl
	ld (MapLocation -3), a


	ld de, MapLocation-2
	call Unpack

;Recopy the last row to prevent a display error from the player 
;hitting a hazard on the ground

	ld hl, (OutPtr)

	ld a, (MapLocation -1)
	ld b, a

_
	dec hl
	djnz -_

	push hl

	ld d,0
	ld e, a
	add hl, de

	ex de, hl

	pop hl

	ld b, 0
	ld c, a
	ldir

	ret


;Draws text on the screen using the 6x8 font


Page1PutTextZeroEnd:

	ld hl, (TextToDisplay)


Read_Text_Loop:	

;HL points to the first character to be drawn.
;PenCol and PenRow are set to the coordinates to
;draw the text at.


	ld a, (PenCol)
	ld c, a		;Saves the pencol coordinates
	

	ld a, (hl)
	or a		;If the string ends in a zero,
			;there is no need to display
			;any more text.

	ret z

	ld a, c		;The font to display is 6x8 pixels,
			;so advance penCol 6 pixels.
	add a, 6
	ld (PenCol), a

;penCol is stored in Register C.  We will need this later.


Draw_Text:



	ld a, (hl)	;Get the character
	push hl

	sub 48	;The font starts at the character "0."
			;So subtract the appropriate amount to get
			;to the right character in the bitmap.




;Although the font is described as "6x8", technically each character
;is 7 pixels high.  So multiply A by 7.

	ld h, 0
	ld l, a
	ld d, h
	ld e, l
	add hl, hl
	add hl, de
	add hl, hl
	add hl, de	
	
	ex de, hl


;If the character is at least lowercase 'a', get the special font
;characters from the language pack.

	cp 49
	jr c, FontStoredOnApp

GetCharacterFromAppVarFont:

	ld ix, (VariableLocation+1)

;The normal font is stored 10 bytes after the beginning of the appvar

	add ix, de

	ld de, (49)*-7
	add ix, de

	ld de, 11
	add ix, de
	push ix
	pop hl

	ld a, (VariableLocation)
	ld de, smallEditRAM

	push bc
	ld b,7

	call DoFlashToRAM

	pop bc

	ld ix, smallEditRAM
	jr LocationGotten

FontStoredOnAPP:
	
	ld ix, Font	;Get to the correct character
			;in the font.

	add ix, de

LocationGotten:

					
	ld b, 7		;The sprite
			;is 7 rows in height.

	ld a, (penRow)		
	ld l, a		;In our sprite routine,
			;L is the Y coordinate.
			;So put penRow into register L.


	ld a, c		;In our sprite routine,
			;Register A is the X coordinate.
			;Register C contains penCol

	Call Put_Sprite_Overwrite

	pop hl		;Advance to the next character in the
			;string
	inc hl

	jr Read_Text_Loop
	






Put_Sprite_Overwrite:


;A sprite routine used to draw the 6x8 routine using
;OVERWRITE -- not XOR, not OR, not AND.

; A = x coordinate
; L = y coordinate
; B = number of rows
; 
; IX = address of sprite



    LD     H, 0
    LD     D, H
    LD     E, L
    ADD    HL, HL
    ADD    HL, DE
    ADD    HL, HL
    ADD    HL, HL


    LD     E, A
    SRL    E
    SRL    E
    SRL    E
    ADD    HL, DE

    LD     DE, plotsscreen
    ADD    HL, DE
   
    
    AND    7
    JR     Z, _AlignedOverwrite


 
    ld de, 11
   
   ld c, a 
 
_RowLoopOverwrite:

    PUSH   BC
    
 
_ColumnLoopOverwrite:
       
	ld b, c

    LD     A, (IX)
    LD C, 0

_ShiftLoopOverwrite:
    SRL    A
    RR C
  
    DJNZ   _ShiftLoopOverwrite
  
    OR (HL)

    LD     (HL), A

    INC   HL
    LD     A, C

    OR (HL)
_

    LD     (HL), A

    INC IX
	
 
	
   ADD    HL, DE
   
    POP    BC
    DJNZ   _RowLoopOverwrite
   
    RET

_AlignedOverwrite:
   
    ld de, 12
     
_PutLoopOverwrite:
    PUSH BC


_PutLoopOverwrite2:
    
    LD     A, (IX)


    
    LD     (HL), A
    INC  IX
 

_PutLoopOverwriteAdd:
    POP BC
 
 ADD HL, DE
 DJNZ _PutLoopOverwrite
 
 RET




BookBonusText:

.db "BOOK_BONUS:_500",0

LevelCompleteText:

.db "LEVEL_COMPLETE",0

WordBonusText:

.db "WORD_BONUS:_500",0

LetterBonusText:

.db "ALL_LETTERS:_100",0






Font:


;;;;;;;;;;;;;;;;;;;;;;;;
;
; THE ENGLISH 6x8 FONT
;
;;;;;;;;;;;;;;;;;;;;;;;;


Numbers:


;DO NOT EDIT THESE VALUES.  The bitmap needs to be 8 pixels wide,
;in 2 colors.

.option BM_SHD = 2
.option bm_min_w = 8


;Numbers for keeping track of score, bitmap for the key,
;the apostrophe character, and the character for displaying how many
;nukes the player has

#include "c:\users\rickie\desktop\slova\Numbers.bmp"


EnglishCharacters:

;The font which contains the English alphabet from A - Z.
;You can make this a different style if you want.


#include "c:\users\rickie\desktop\slova\Regular Font.z80"


Extend:

;The main use of these characters is to fill the gap from uppercase
;Z to lowercase a.  So there are six more characters in the font

;Character "-"

.db 0,0,0,%11111000,0,0,0

;Question Mark

.db %01110000
.db %10001000
.db %00001000
.db %00010000
.db %00100000
.db %00000000
.db %00100000

;Character "."

.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %00110000
.db %00110000

;Character ","

.db %00000000
.db %00000000
.db %00000000
.db %00000000
.db %01100000
.db %00100000
.db %01000000
;The " " character

.db 0,0,0,0,0,0,0

;A picture of a shield -- how many shields the player has left.


.db %10101000
.db %11111000
.db %10001000
.db %10101000
.db %10101000
.db %10001000
.db %01110000






Levels:

#include "c:\users\Rickie\Desktop\Slova\Levels.asm"



Page1PlaceGruzzle:

;Where is the gruzzle to be placed in the list of
;gruzzles?


	ld hl, (BadQuestion+1)

;Which gruzzle is to be placed?

	ld a, (BadQuestion)
	sub 27

	ld (hl), a

	push hl
	pop ix

;Store the X and Y coordinates of the gruzzle

	ld hl, (GruzzleWarning+3)
	ld a, l
	and %11110000
	ld l, a
	ld de, 48
	add hl, de


	ld (ix+1), l
	ld (ix+2), h


	ld hl, (GruzzleWarning+5)
	ld a, l
	and %11110000
	ld l, a
	ld de, 32
	add hl, de


	ld (ix+3), l
	ld (ix+4), h

	ld (ix+5), 1
	ld (ix+6), 0

	ret







Page1ConvertScoreToText:

		

; HL:DE INPUT
; BC POINTS TO OUTPUT

long2ascii:

		ld hl, (Score)
		ld de, (Score +2)
		ld bc, Hud_String1 + 6
						; HL = HIGH WORD
		PUSH	DE
		EXX
		POP		HL		; HL' = LOW WORD
		EXX

		LD  E,C
		LD  D,B
				
		LD  BC,-1000000000/$10000 -1
		EXX
		LD  BC,-1000000000&$FFFF
		EXX
		CALL    NUM1
		
		LD  BC,-100000000/$10000 -1
		EXX
		LD  BC,-100000000&$FFFF
		EXX
		CALL    NUM1
		
		LD  BC,-10000000/$10000 -1
		EXX
		LD  BC,-10000000&$FFFF
		EXX
		CALL    NUM1
		
		LD  BC,-1000000/$10000 -1
		EXX
		LD  BC,-1000000&$FFFF
		EXX
		CALL    NUM1
		
		LD  BC,-100000/$10000 -1
		EXX
		LD  BC,-100000&$FFFF
		EXX
		CALL    NUM1
		
		LD  BC,-10000/$10000 -1
		EXX
		LD  BC,-10000&$FFFF
		EXX
		CALL    NUM1
		
		LD  BC,-1000/$10000 -1
		EXX
		LD  BC,-1000&$FFFF
		EXX
		CALL    NUM1
		
		LD  BC,-100/$10000 -1
		EXX
		LD  BC,-100&$FFFF
		EXX
		CALL    NUM1
		
		LD  BC,-10/$10000 -1
		EXX
		LD  BC,-10&$FFFF
		EXX
		CALL    NUM1
		
		LD  BC,-1/$10000 -1
		EXX
		LD  BC,-1&$FFFF
		EXX
		CALL    NUM1
		RET

NUM1:   LD  A,'0'-1  ; '0' IN THE TILESET

NUM2:   INC A
		EXX
		add	HL,BC		; low word
		EXX
		ADC	HL,BC		; high word
		jp  C,NUM2
		
		EXX
		SBC HL,BC		; low word
		EXX
		SBC HL,BC		; high word
		
		LD  (DE),A
		INC DE
		RET
